$conf = {}

# @initNode 初期ノード。
#   空白(改行を含む)で区切って記述する
#   前(上)に書いてあるものが優先される
$conf["initNode"] = %w(
  shingetsu.s45.xrea.com:80/index.cgi
  fuktommy.ddo.jp:8000/server.cgi
  yanga.s51.xrea.com:80/shingetsu/node.xcg
)

# バージョンを表わす文字列
$conf["version"] = "shinGETsu/0.4.1(hamayu/0.01)"
# デバッグモードで動作させるか
$conf["debug"] = false
# フォアグラウンドで動作させるか
$conf["fg"] = true

# 待ち受けポート(TCP)
$conf["port"] = 9000
# 接続してきた相手のDNS名を逆引きするかどうか
$conf["resolv"] = false
# ゲートウェイでのデータ削除やクライアントの実行を許すホスト
# IPアドレスの正規表現で指定する。
# 例えば "127.0.0.1" なら自分だけ、"." なら誰にでも許可となる
$conf["adminAddr"] = "."  # regxp
# ゲートウェイで掲示板の読み書きを許すホスト
# $adminAddrと同様に指定する
$conf["friendAddr"] = "." # regxp
# server.cgiのURIパスのabs_path部分
$conf["path"] = "/server.cgi"
# CGIのある、URL上のパス
$conf["root"] = "/"
# /が呼ばれたときに表示するcgi
$conf["index"] = "/gateway.cgi"
# CGIのあるディレクトリ名。絶対パスでも相対パスでもよい
$conf["cgiDir"] = "" # "./cgi-bin"
# CSSのURL上のパス
$conf["css"] = "/default.css"
# 動作時のumask値(8進数)
$conf["umask"] = 0022
# 子プロセスの UID
# $conf["user"] = "nobody"
# 子プロセスの GID
# $conf["group"] = "nobody"
# syslog ファシリティ名。syslog に記録しない場合は「none」を指定する
$conf["syslog"] = "none"

# *.cgiの最小プロセス数
$conf["min-servers"] = 2
# *.cgiの最大プロセス数
$conf["max-servers"] = 5
# *.cgiの1プロセスあたりの最大接続回数 この回数に達するとプロセスを終了
$conf["max-use"] = 50
# *.cgiプロセスの最大接続待ち時間(秒)
$conf["max-idle"] = 100

# キャッシュのディレクトリ名。絶対パスでも相対パスでもよい
$conf["datadir"] = "./dat"
# ファイル置場のディレクトリ名。絶対パスでも相対パスでもよい
$conf["filedir"] = "./file"


# サーバの説明やネットワーク利用条件
$conf["motd"]       = $conf["filedir"] + "/motd.txt"
# ノードのリスト
$conf["nodelist"]   = $conf["datadir"] + "/node.txt"
# 過去24時間以内の投稿IDのリスト
$conf["updatelist"] = $conf["datadir"] + "/update.txt"
# ロックのためのファイル
$conf["lock"]       = $conf["datadir"] + "/lock.txt"
# デバッグモードでないときにプロセスIDを記録する
$conf["pid"]        = $conf["datadir"] + "/pid.txt"
# クライアントの処理が終了した時刻を記録する
$conf["client"]     = $conf["datadir"] + "/client.txt"
# キャッシュの行数や最終書き込み時刻などを記録する
$conf["stat"]       = $conf["datadir"] + "/stat.txt"

$conf["trust"]      = $conf["datadir"] + "/trust.txt"


# データの送受信を行うときのバッファサイズ(bytes)
$conf["bufsize"] = 8192
# データの送受信の制限時間(秒)
$conf["timeout"] = 30
# 接続確認する間隔(分)
$conf["pingfrec"] = 10
# client.cgiプロセスの最大生存時間(分) < $syncfrec
$conf["timeout_client"] = 30
# キャッシュを最新の状態に保つための間隔(分) > $timeout_client
$conf["syncfrec"] = 60
# 初期ノードに再接続するための間隔(分)
$conf["initfrec"] = 25
# client.cgiを実行する間隔(分)
$conf["clientfrec"] = 5
# どれくらい以前の投稿まで検索するか(時間)
$conf["syncsafety"] = 10 * 24
# 投稿があったことをいつまで記憶するか(分)
$conf["saveupdate"] = 24 * 60
# 投稿時間にどのくらい誤差を含ませるか(秒)
$conf["timeError"] = 60

# 接続失敗したときの再接続回数
$conf["retry"] = 5
# ファイル検索のときの検索の深さの目安
$conf["retrySearch"] = 5
# ファイル検索のときの検索の深さの目安
$conf["searchDepth"] = 30
# ファイルが大きすぎるなどの理由で取得に失敗したときの再取得回数
$conf["retryGet"] = 3
# 接続するノード数の目安
$conf["nodes"] = 5
# ファイルの最大サイズの目安(Mega bytes)
$conf["filelimit"] = 10

# Gateway -------------------------------------------------------------

# /MENUで特にファイル名が設定されない場合の値
$conf["menufile"] = "menu"
# リダイレクタ構想に基づき、shingetsu{1,2}.p2p を内部で
# /tradgw.cgiや/gateway.cgiに置き換えるかどうか
$conf["redirect"] = true
# メッセージのデフォルトの言語コード(RFC3066を参照)
$conf["language"] = "en"

$conf["google"] = "http://www.google.co.jp/search"

# 外部コマンドの一覧
$conf["command"] = {
   "gzip"     => "gzip -c",
   "gunzip2"  => "gunzip -c",
   "md5sum"   => "md5sum",
   "uuencode" => "uuencode -m",
   "uudecode" => "uudecode",
   "apollo"   => "../contrib/apollo",
}

if RUBY_PLATFORM =~ /freebsd/
   $conf["command"]["md5sum"]   = "md5"
   $conf["command"]["uudecode"] = "uudecode -p"
end

# 拡張子とContent-typeの組み合わせを1行に1つづつ書く
# 1行は拡張子とContent-typeを空白文字(タブ含む)で区切って書く

# %w     空白区切りで配列化         txt plain        -->  ["txt", "plain"]
# *      配列を関数の引数形式に変換 ["txt", "plain"] -->  "txt", "plain"
# Hash[] 引数の奇数番目をキーに、偶数番目を値にしたハッシュを生成
$conf["mimeType"] = Hash[*%w(
   avi   video/x-msvideo
   bin   application/octet-stream
   bmp   image/bmp
   cpio  application/x-cpio
   css   text/css
   csv   text/comma-separated-values
   dvi   application/x-dvi
   gif   image/gif
   html  text/html
   ico   image/x-icon
   jar   application/x-java-archive
   jpg   image/jpeg
   lzh   application/x-lzh
   mid   audio/midi
   mov   video/quicktime
   mp3   audio/mpeg
   mpg   video/mpeg
   ogg   application/x-ogg
   pdf   application/pdf
   pgp   application/pgp-signature
   png   image/png
   ps    application/postscript
   ra    audio/x-realaudio
   rb    text/html
   rpm   application/x-redhat-package-manager
   swf   application/x-shockwave-flash
   tar   application/x-tar
   tex   application/x-tex
   tif   image/tiff
   txt   text/plain
   tgz   application/x-gtar
   wav   audio/x-wav
   xml   text/xml
   zip   application/zip
)]
