require 'util'

module Extern
  module_function

  #
  # mime base-64 encode
  #
  def base64encode(bin)
    require "base64"
    return encode64(bin).gsub(/[\r\n]/, "")
  end

  #
  # mime base-64 decode
  #
  def base64decode(str)
    require "base64"
    return decode64(str)
  end

  #
  # md5 message-digest
  #
  def md5digest(bin)
    require 'md5'
    return Digest::MD5.hexdigest(bin)
  end

  #
  # pubkey to trip
  #
  def pubkey2trip(str)
    m = md5digest(str)
    return base64encode(m)[0..11]
  end

  #
  # gzip
  #
  def xgzip(arg)
    Util.printtrace() ## debug

    comp = ""
    IO.popen("gzip -c", "r+") {|io|
      io.print arg
      io.close_write
      comp = io.read
    }
    return comp
  end

  #
  # gunzip
  #
  def xgunzip(arg)
    Util.printtrace() ## debug

    buf = ""
    IO.popen("gunzip -c", "r+") {|io|
      io.print arg
      io.close_write
      buf = io.read
    }

    lines = buf.split(/\n/)
    lines.collect! {|line|
      line += "\n"
    }

    if buf !~ /\n$/ then
      lines[-1].chop!    # cut LF of last line
    end

    return lines
  end
end

