module Message
  module_function
  #
  # list  =  ja;q=1.0,en;q=0.9
  #
  def load(list)
    require "config"

    q    = {}  # Hash
    lang = []  # Array

    if list then
      list.split(/,/).each {|s|
        if s =~ /\s*;/ then
          lng = $`
          if $' =~ /q=\s*/ then
            q[lng] = $'.to_f
          end
        else
          q[s] = 1.0
        end
      }
      lang = q.keys.sort {|a,b| q[b] <=> q[a]}
    end

    lng = $conf["language"]
    lang.each {|s|
      if FileTest.exist?("#{$conf["filedir"]}/message-#{s}.txt") then
        lng = s
        break
      end
    }

    msg  = {}

    require 'uri'
    IO.foreach("#{$conf["filedir"]}/message-#{lng}.txt") {|line|
      line.chomp!
      next if line =~ /^\#$/
      bufs = line.split(/<>/)
      next if bufs.size != 2
      msg[bufs[0]] = URI.decode(bufs[1])
    }
    return msg
  rescue Errno::ENOENT, Errno::EACCES
    raise "faild to open #{$conf["filedir"]}/message-#{lng}.txt. #{$!}"
  end
end
